/* Generated automatically by genconfig.  DO NOT EDIT */

/* The small program gauche-config is installed in the same place
   as gosh, and used to retrieve various configuration information
   later.  It is made a separate program from gosh for quicker
   startup and avoiding complications of dynamic library etc.
   It used to be a shell script, but turned into a C program
   so that it works on the platform that lacks sh. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <ctype.h>

#ifdef __MINGW32__
#include <windows.h>
#include <shlwapi.h>
#endif

static void usage (void) {
   puts("Usage: gauche-config [option]\n"
        "\n"
        "General parameter\n"
        "  -V   the current gauche version\n"
        "\n"
        "Parameters to compile an application using Gauche\n"
        "  -I   include paths required to compile programs using gauche\n"
        "  -L   library paths required to link programs using gauche\n"
        "  -l   libraries required to link programs using gauche\n"
        "  --cc name of the compiler\n"
        "  --ac directory that contains Gauche specific autoconf macro\n"
        "  --reconfigure\n"
        "       prints the command line used to configure the current\n"
        "       installation.\n"
        "  --arch\n"
        "       prints the architecture signature\n"
        "\n"
        "Parameters to install files\n"
        "  --{sys|site|pkg}libdir\n"
        "       directories where system|site|package scheme files go\n"
        "  --{sys|site|pkg}archdir\n"
        "       directories where system|site|package DSO files go\n"
        "  --{sys|site|pkg}incdir\n"
        "       directories where system|site|package header files of extensions go\n"
        "  --mandir/--infodir\n"
        "       directories where gauche manpage and info docs are installed\n"
        "\n"
        "Parameters to help building extensions\n"
        "  --object-suffix\n"
        "       Returns extension of the compiled objects (e.g. 'o')\n"
        "  --executable-suffix\n"
        "       Returns extension of the executable (mostly empty, sometimes '.exe')\n"
        "  --so-suffix\n"
        "       Suffix for dynamically loadable (dlopen-able) modules\n"
        "  --so-cflags\n"
        "       CFLAGS to create dynamically loadable modules\n"
        "  --so-ldflags\n"
        "       LDFLAGS to create dynamically loadable modules\n"
        "  --so-libs\n"
        "       Required libraries to create dynamically loadable modules\n"
        "  --dylib-suffix\n"
        "       Suffix for dynamically linked libraries\n"
        "  --dylib-ldflags\n"
        "       LDFLAGS to create dynamically linked libraries\n"
        "  --fixup-extension FILE [MODULE]\n"
        "       creates FILE_head.c and FILE_tail.c.  They are required for GC\n"
        "       to work properly on some platforms.  MODULE must be the extension\n"
        "       module's name, and has to match the name given to the\n"
        "       SCM_INIT_EXTENSION macro in the extension initialization code. \n"
        "       If MODULE is omitted, FILE is used as the module's name.\n"
        );
    exit(1);
}

static struct cmd_rec {
    const char *cmd;
    const char *value;
} cmds[] = {
    { "-V", "0.8.11" },
    { "-I", "-I/usr/lib64/gauche/0.8.11/include" },
    { "-L", "-L/usr/lib64/gauche/0.8.11/x86_64-redhat-linux-gnu " },
    { "--ac", "/usr/share/gauche/0.8.11/" },
    { "-l", "-lgauche -ldl -lcrypt -lutil -lm  -lpthread" },
    { "--cc", "gcc" },
    { "--reconfigure", "./configure '--build=x86_64-redhat-linux-gnu' '--host=x86_64-redhat-linux-gnu' '--target=x86_64-redhat-linux-gnu' '--program-prefix=' '--prefix=/usr' '--exec-prefix=/usr' '--bindir=/usr/bin' '--sbindir=/usr/sbin' '--sysconfdir=/etc' '--datadir=/usr/share' '--includedir=/usr/include' '--libdir=/usr/lib64' '--libexecdir=/usr/libexec' '--localstatedir=/var' '--sharedstatedir=/usr/com' '--mandir=/usr/share/man' '--infodir=/usr/share/info' '--with-rpath=no' '--enable-threads=pthreads' '--enable-multibyte=utf-8' 'CFLAGS=-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m64 -mtune=generic' 'build_alias=x86_64-redhat-linux-gnu' 'host_alias=x86_64-redhat-linux-gnu' 'target_alias=x86_64-redhat-linux-gnu'" },

    { "--prefix",      "/usr" },
    { "--sysincdir",   "/usr/lib64/gauche/0.8.11/include" },
    { "--siteincdir",  "/usr/lib64/gauche/site/include" },
    { "--pkgincdir",   "${libdir}/gauche/site/include" },
    { "--syslibdir",   "/usr/share/gauche/0.8.11/lib" },
    { "--sitelibdir",  "/usr/share/gauche/site/lib" },
    { "--pkglibdir",   "${datadir}/gauche/site/lib" },
    { "--sysarchdir",  "/usr/lib64/gauche/0.8.11/x86_64-redhat-linux-gnu" },
    { "--sitearchdir", "/usr/lib64/gauche/site/0.8.11/x86_64-redhat-linux-gnu" },
    { "--pkgarchdir",  "${libdir}/gauche/site/0.8.11/x86_64-redhat-linux-gnu" },
    { "--mandir",      "/usr/share/man" },
    { "--infodir",     "/usr/share/info" },
    { "--arch",        "x86_64-redhat-linux-gnu" },

    { "--local-incdir", "" },
    { "--local-libdir", "" },

    { "--default-cflags", "-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector --param=ssp-buffer-size=4 -m64 -mtune=generic" },

    { "--object-suffix",  "o" },
    { "--executable-suffix", "" },
    { "--so-suffix",      "so" },
    { "--so-cflags",      "-fPIC" },
    { "--so-ldflags",     " -shared -o" },
    { "--so-libs",        "" },
    { "--dylib-suffix",   "so" },
    { "--dylib-ldflags",  " -shared -o" },
    { "--libgauche-so",   "libgauche.so" },

    { NULL, NULL }
};

static void print_output(struct cmd_rec *cmd) 
{
#if !defined(__MINGW32__)
    printf("%s\n", cmd->value);
#else   /* __MINGW32__ */
    const char *dir_mark;

    if ((dir_mark = strchr(cmd->value, '@')) == NULL) {
	printf("%s\n", cmd->value);
    } else {
	HMODULE mod;
	DWORD r;
	char path[MAX_PATH];
	char *p;

	mod = GetModuleHandle(NULL);
	if (mod == NULL) {
	    fprintf(stderr, "GetModuleHandle failed");
	    exit(1);
	}
	r = GetModuleFileName(mod, path, MAX_PATH);
	if (r == 0) {
	    fprintf(stderr, "GetModuleFileName failed");
	    exit(1);
	}
	/* remove \gauche-config.exe */
	if (!PathRemoveFileSpec(path)) {
	    fprintf(stderr, "PathRemoveFileSpec failed on %s", path);
	    exit(1);
	}
	/* remobe \bin */
	if (!PathRemoveFileSpec(path)) {
	    fprintf(stderr, "PathRemoveFileSpec failed on %s", path);
	    exit(1);
	}
	
	fwrite(cmd->value, dir_mark - cmd->value, 1, stdout);
	fprintf(stdout, "%s%s\n", path, dir_mark+1);
    }
#endif  /* __MINGW32__ */
}

static void fixup_extension(int argc, char **argv)
{
    const char *file, *module;
    char *outfile, *m = NULL;
    FILE *fp;

    if (argc < 3) usage();
    file = argv[2];
    if (argc > 3) {
        module = argv[3];
    } else {
        const char *f;
        char *mm;
        m = (char *)malloc(strlen(file)+1);
        for (f = file, mm = m; *f; f++, mm++) {
           if (isalnum(*f)) *mm = *f;
           else *mm = '_';
        }
        *mm = '\0';
        module = m;
    }
    
    outfile = (char *)malloc(strlen(file) + sizeof("_head.c") + 1);
    strcpy(outfile, file);
    strcat(outfile, "_head.c");
    fp = fopen(outfile, "w");
    if (fp == NULL) {
        fprintf(stderr, "gauche-config: couldn't create %s: %s",
                outfile, strerror(errno));
        exit(1);
    }
    fprintf(fp, "void *Scm__datastart_%s = (void*)&Scm__datastart_%s;\n",
            module, module);
    fprintf(fp, "void *Scm__bssstart_%s;\n", module);
    fclose(fp);

    strcpy(outfile, file);
    strcat(outfile, "_tail.c");
    fp = fopen(outfile, "w");
    if (fp == NULL) {
        fprintf(stderr, "gauche-config: couldn't create %s: %s",
                outfile, strerror(errno));
        exit(1);
    }
    fprintf(fp, "void *Scm__dataend_%s = (void*)&Scm__dataend_%s;\n",
            module, module);
    fprintf(fp, "void *Scm__bssend_%s;\n", module);
    fclose(fp);

    free(outfile);
    if (m) free(m);
}

int main(int argc, char **argv)
{
    if (argc < 2) usage();
    if (strcmp(argv[1], "--fixup-extension") == 0) {
        fixup_extension(argc, argv);
    } else {
        struct cmd_rec *cp = cmds;

        while (cp->cmd != NULL) {
            if (strcmp(cp->cmd, argv[1]) == 0) {
                print_output(cp);
                exit(0);
            }
            cp++;
        }
        usage();
    }
    return 0;
}

